from abc import abstractmethod
from logging import Logger
from typing import Any, Final, Iterator


class BaseSolver:
    def __init__(self, logger: Logger, year: int, day: int):
        self.logger: Final = logger
        self.year: Final = year
        self.day: Final = day

    @abstractmethod
    def solve(self, input: str) -> Iterator[Any]: ...
